unit SettingsUnit;

interface

uses
	SysUtils, Classes, QForms, QStdCtrls, QControls, QExtCtrls;

type
	TSettingsForm = class(TForm)
    UseProxyCheckBox: TCheckBox;
		ProxyEdit: TEdit;
    Label1: TLabel;
		GlobalCookieEdit: TEdit;
    Label2: TLabel;
		LocalCookieEdit: TEdit;
		Bevel1: TBevel;
    OKButton: TButton;
    CancelButton: TButton;
    PostSettingsGroupBox: TGroupBox;
    UseEZCodesCheckBox: TCheckBox;
    UseEmoticonsCheckBox: TCheckBox;
		UseLinkConversionCheckBox: TCheckBox;
    UseHTMLCheckBox: TCheckBox;
    EmailRepliesCheckBox: TCheckBox;
    CheckForUpdatesCheckBox: TCheckBox;
    UpdateIntervalEdit: TEdit;
		Label3: TLabel;
    MarkForumsReadCheckBox: TCheckBox;
    GlobalLoginButton: TButton;
    LocalLoginButton: TButton;
    Bevel2: TBevel;
    Label4: TLabel;
    ForumNameEdit: TEdit;
    ButtonLayoutGroupBox: TGroupBox;
    RadioButton1: TRadioButton;
    RadioButton2: TRadioButton;
    RadioButton3: TRadioButton;
    RadioButton4: TRadioButton;
    RadioButton5: TRadioButton;
    RadioButton6: TRadioButton;
    RadioButton7: TRadioButton;
    RadioButton8: TRadioButton;
    Label5: TLabel;
    TimeCorrectionEdit: TEdit;
    Label6: TLabel;
    HideAutoUpdatesCheckBox: TCheckBox;
    HideManualUpdatesCheckBox: TCheckBox;
		HideTopicDownloadsCheckBox: TCheckBox;
		HideInitUpdatesCheckBox: TCheckBox;
    UseProxyVariableCheckBox: TCheckBox;
		procedure UseProxyCheckBoxClick(Sender: TObject);
		procedure FormShow(Sender: TObject);
		procedure UseHTMLCheckBoxClick(Sender: TObject);
		procedure CheckForUpdatesCheckBoxClick(Sender: TObject);
		procedure GlobalLoginButtonClick(Sender: TObject);
		procedure LocalLoginButtonClick(Sender: TObject);
		procedure HideUpdatesCheckBoxClick(Sender: TObject);
    procedure UseProxyVariableCheckBoxClick(Sender: TObject);
	private
	public
	end;

implementation

{$R *.dfm}

uses
	MainUnit, GlobalLoginUnit, LocalLoginUnit;

procedure TSettingsForm.UseProxyCheckBoxClick(Sender: TObject);
begin
	ProxyEdit.Enabled := UseProxyCheckBox.Checked;
end;

procedure TSettingsForm.FormShow(Sender: TObject);
begin
	UseProxyVariableCheckBoxClick (Sender);
	CheckForUpdatesCheckBoxClick (Sender);
	HideUpdatesCheckBoxClick (Sender);
	UseHTMLCheckBoxClick (Sender);
end;

procedure TSettingsForm.UseHTMLCheckBoxClick(Sender: TObject);
begin
	UseEZCodesCheckBox.Enabled := not UseHTMLCheckBox.Checked;
	UseEmoticonsCheckBox.Enabled := not UseHTMLCheckBox.Checked;
	UseLinkConversionCheckBox.Enabled := not UseHTMLCheckBox.Checked;
	if not UseEZCodesCheckBox.Enabled then
		UseEZCodesCheckBox.Checked := False;
	if not UseEmoticonsCheckBox.Enabled then
		UseEmoticonsCheckBox.Checked := False;
	if not UseLinkConversionCheckBox.Enabled then
		UseLinkConversionCheckBox.Checked := False;
end;

procedure TSettingsForm.CheckForUpdatesCheckBoxClick(Sender: TObject);
begin
	UpdateIntervalEdit.Enabled := CheckForUpdatesCheckBox.Checked;
	HideAutoUpdatesCheckBox.Enabled := CheckForUpdatesCheckBox.Checked;
end;

procedure TSettingsForm.GlobalLoginButtonClick(Sender: TObject);
begin
	with TGlobalLoginForm.Create (Self) do try
		if ShowModal = mrOK then
			MainForm.GlobalLogin (UserNameEdit.Text, PasswordEdit.Text);
	finally
		Free;
	end;
end;

procedure TSettingsForm.LocalLoginButtonClick(Sender: TObject);
var
	BoardName: string;
	P: Integer;
begin
	with TLocalLoginForm.Create (Self) do try
		BoardName := MainForm.URLID;
		if LowerCase (Copy (BoardName, 1, 1)) = 'f' then
			Delete (BoardName, 1, 1);
		P := Pos ('frm', LowerCase (BoardName));
		if P > 0 then
			Delete (BoardName, P, Length (BoardName));
		BoardNameEdit.Text := BoardName;
		if ShowModal = mrOK then
			MainForm.LocalLogin (UserNameEdit.Text, PasswordEdit.Text, BoardNameEdit.Text);
	finally
		Free;
	end;
end;

procedure TSettingsForm.HideUpdatesCheckBoxClick(Sender: TObject);
begin
	MarkForumsReadCheckBox.Enabled := not (HideInitUpdatesCheckBox.Checked and HideAutoUpdatesCheckBox.Checked and HideManualUpdatesCheckBox.Checked);
	if not MarkForumsReadCheckBox.Enabled then
		MarkForumsReadCheckBox.Checked := False;
end;

procedure TSettingsForm.UseProxyVariableCheckBoxClick(Sender: TObject);
begin
	UseProxyCheckBox.Enabled := not UseProxyVariableCheckBox.Checked;
	if UseProxyVariableCheckBox.Checked then
		with MainForm do begin
			UseProxyCheckBox.Checked := (Length (ProxyVariable) > 0) and (ProxyVariablePort <> 0);
			if UseProxyCheckBox.Checked then
				ProxyEdit.Text := ProxyVariable + ':' + IntToStr (ProxyVariablePort)
			else
				ProxyEdit.Text := '';
		end;
	UseProxyCheckBoxClick (Sender);
end;

end.
