unit AliasesUnit;

interface

uses
	SysUtils, Classes, QGraphics, QControls, QForms, QDialogs,
  QExtCtrls, QStdCtrls, QComCtrls;

type
  TAliasesForm = class(TForm)
    AliasList: TListView;
    AddButton: TButton;
    Bevel1: TBevel;
    OKButton: TButton;
    CancelButton: TButton;
    procedure AddButtonClick(Sender: TObject);
    procedure AliasListDblClick(Sender: TObject);
    procedure AliasListKeyDown(Sender: TObject; var Key: Word;
      Shift: TShiftState);
    procedure AliasListEditing(Sender: TObject; Item: TListItem;
      var AllowEdit: Boolean);
    procedure AliasListEdited(Sender: TObject; Item: TListItem;
			var S: WideString);
    procedure AliasListClick(Sender: TObject);
  private
	public
	end;

implementation

{$R *.dfm}

uses
	AliasPropUnit;

procedure TAliasesForm.AddButtonClick(Sender: TObject);
begin
	with TAliasPropForm.Create (Self) do try
		if ShowModal = mrOK then begin
			with AliasList.Items.Add do begin
				Caption := UserIDEdit.Text;
				SubItems.Add (ReplacementEdit.Text);
			end;
		end;
	finally
		Free;
	end;
end;

procedure TAliasesForm.AliasListDblClick(Sender: TObject);
begin
	if Assigned (AliasList.Selected) then
		with TAliasPropForm.Create (Self) do try
			with AliasList.Selected do begin
				UserIDEdit.Text := Caption;
				ReplacementEdit.Text := SubItems [0];
				if ShowModal = mrOK then begin
					Caption := UserIDEdit.Text;
					SubItems [0] := ReplacementEdit.Text;
				end;
			end;
		finally
			Free;
		end;
end;

procedure TAliasesForm.AliasListKeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
	case Key of
		13:
			AliasListDblClick (Sender);
		8:
			if Assigned (AliasList.Selected) then
				AliasList.Selected.Free;
	end;
end;

procedure TAliasesForm.AliasListEditing(Sender: TObject; Item: TListItem;
	var AllowEdit: Boolean);
begin
	AllowEdit := True;
	AliasList.OnKeyDown := nil;
end;

procedure TAliasesForm.AliasListEdited(Sender: TObject; Item: TListItem;
	var S: WideString);
begin
	AliasList.OnKeyDown := AliasListKeyDown;
end;

procedure TAliasesForm.AliasListClick(Sender: TObject);
begin
	AliasList.OnKeyDown := AliasListKeyDown;
end;

end.
