unit UtilsWin;

interface

uses
	QForms;

type
	TDefaultMessageType = (mtDefault, mtInformation, mtQuestion, mtWarning, mtProgramError, mtDeviceError);

const
	idOK = smbOK;
	idCancel = smbCancel;
	idYes = smbYes;
	idNo = smbNo;
	idAbort = smbAbort;
	idRetry = smbRetry;
	idIgnore = smbIgnore;

function ShowDefaultMessageBox(const Content, Title: string; MessageType: TDefaultMessageType = mtDefault; Critical: Boolean = False): TMessageButton;

implementation

function ShowDefaultMessageBox;
var
	Buttons: TMessageButtons;
	Style:   TMessageStyle;
begin
	case MessageType of
		mtQuestion: begin
			if Critical then
				Buttons := [smbYes, smbNo, smbCancel]
			else
				Buttons := [smbYes, smbNo];
			Style := smsInformation;
		end;
		mtWarning: begin
			if Critical then
				Buttons := [smbOK, smbCancel]
			else
				Buttons := [smbOK];
			Style := smsWarning;
		end;
		mtProgramError: begin
			if Critical then
				Buttons := [smbOK, smbCancel]
			else
				Buttons := [smbOK];
			Style := smsCritical;
		end;
		mtDeviceError: begin
			if Critical then
				Buttons := [smbRetry, smbCancel]
			else
				Buttons := [smbAbort, smbRetry, smbIgnore];
			Style := smsCritical;
		end;
		else begin
			if Critical then
				Buttons := [smbOK, smbCancel]
			else
				Buttons := [smbOK];
			Style := smsInformation;
		end;
	end;
	Result := Application.MessageBox (Content, Title, Buttons, Style);
end;

end.
