unit URLLabelUnit;

interface

uses
	SysUtils, Classes, QGraphics, QControls, QStdCtrls;

type
	TURLLabel = class(TLabel)
	private
		FURL: string;
	public
		constructor Create(AOwner: TComponent); override;
		procedure Click; override;
	published
		property URL: string read FURL write FURL;
	end;

procedure Register;

implementation

uses
	LibC;

procedure Register;
begin
	RegisterComponents('User', [TURLLabel]);
end;

{ TURLLabel }

procedure TURLLabel.Click;
var
	ArgList: array [0..2] of PChar;
begin
	inherited;
	if Length (URL) > 0 then begin
		if LibC.Fork = 0 then begin
			ArgList [0] := 'x-www-browser';
			ArgList [1] := PChar (URL);
			ArgList [2] := nil;
			LibC.ExecVP ('x-www-browser', PPChar (@ArgList));
			Halt;
		end;
	end;
end;

constructor TURLLabel.Create(AOwner: TComponent);
begin
	inherited;
	Font.Color := clHighlight;
	Font.Style := Font.Style + [fsUnderline];
	Cursor := crHandPoint;
	FURL := '';
end;

end.
